/////////////////////////////////////////////////////////////////
//                                                             
// own_types.h, 09/11/00, Ilja Friedel                         
//
/////////////////////////////////////////////////////////////////
//                                                             
// Status: ok
//                                                             
/////////////////////////////////////////////////////////////////
//                                                             
// This file defines integer types for the libseq package.
// It is important for portability.
//                                                             
/////////////////////////////////////////////////////////////////

#ifndef OWN_TYPES_USED
#define OWN_TYPES_USED

/////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

/////////////////////////////////////////////////////////////////

#include "options.h"

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

typedef unsigned short      US_int;  // 16 bit without sign    //
typedef unsigned long       UL_int;  // 32 bit without sign    //
typedef unsigned long long ULL_int;  // 64 bit without sign    //
typedef          short       S_int;  // 16 bit with sign       //
typedef          long        L_int;  // 32 bit with sign       //
typedef          long long  LL_int;  // 64 bit with sign       //

typedef UL_int             R_Elem;   // ring elements          //
typedef UL_int             FixPoint; // fixed point reals      //
typedef UL_int             RVector;  // vector over ring       //

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

extern void check_own_types(void);

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

#endif
